<?xml version="1.0" encoding="utf-8"?>
<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
	xmlns:qsp="http://iekko.free.fr/devel/qsp">

	<xsl:output method="html" />

	<xsl:template match="/">
		<html>
			<head>
				<link rel="stylesheet" type="text/css" media="screen" href="screen.css" />
			</head>
			<body>
				<script type="text/javascript">
					function expandAllProperties() {
						var elements;
						var element;
						elements = document.getElementsByTagName("div");
						for (i = 0; i &lt; elements.length; i++) {
							element = elements[i];
							if (element.className == "properties") {
								element.style.display = "block";
							}
						}
						elements = document.getElementsByTagName("a");
						for (i = 0; i &lt; elements.length; i++) {
							element = elements[i];
							if (element.id.match(/^expandProperties:/)) {
								element.style.display = "none";
							} else if (element.id.match(/^collapseProperties:/)) {
								element.style.display = "inline";
							}
						}
					}
					function collapseAllProperties() {
						var elements;
						var element;
						elements = document.getElementsByTagName("div");
						for (i = 0; i &lt; elements.length; i++) {
							element = elements[i];
							if (element.className == "properties") {
								element.style.display = "none";
							}
						}
						elements = document.getElementsByTagName("a");
						for (i = 0; i &lt; elements.length; i++) {
							element = elements[i];
							if (element.id.match(/^expandProperties:/)) {
								element.style.display = "inline";
							} else if (element.id.match(/^collapseProperties:/)) {
								element.style.display = "none";
							}
						}
					}
					function expandProperties(server) {
						document.getElementById("properties:" + server)
								.getElementsByTagName("td")[0]
								.getElementsByTagName("div")[0]
								.style.display = "block";
						document.getElementById("expandProperties:" + server)
								.style.display = "none";
						document.getElementById("collapseProperties:" + server)
								.style.display = "inline";
					}
					function collapseProperties(server) {
						document.getElementById("properties:" + server)
								.getElementsByTagName("td")[0]
								.getElementsByTagName("div")[0]
								.style.display = "none";
						document.getElementById("expandProperties:" + server)
								.style.display = "inline";
						document.getElementById("collapseProperties:" + server)
								.style.display = "none";
					}
					function expandAllPlayers() {
						var elements;
						var element;
						elements = document.getElementsByTagName("div");
						for (i = 0; i &lt; elements.length; i++) {
							element = elements[i];
							if (element.className == "players") {
								element.style.display = "block";
							}
						}
						elements = document.getElementsByTagName("a");
						for (i = 0; i &lt; elements.length; i++) {
							element = elements[i];
							if (element.id.match(/^expandPlayers:/)) {
								element.style.display = "none";
							} else if (element.id.match(/^collapsePlayers:/)) {
								element.style.display = "inline";
							}
						}
					}
					function collapseAllPlayers() {
						var elements;
						var element;
						elements = document.getElementsByTagName("div");
						for (i = 0; i &lt; elements.length; i++) {
							element = elements[i];
							if (element.className == "players") {
								element.style.display = "none";
							}
						}
						elements = document.getElementsByTagName("a");
						for (i = 0; i &lt; elements.length; i++) {
							element = elements[i];
							if (element.id.match(/^expandPlayers:/)) {
								element.style.display = "inline";
							} else if (element.id.match(/^collapsePlayers:/)) {
								element.style.display = "none";
							}
						}
					}
					function expandPlayers(server) {
						document.getElementById("players:" + server)
								.getElementsByTagName("td")[0]
								.getElementsByTagName("div")[0]
								.style.display = "block";
						document.getElementById("expandPlayers:" + server)
								.style.display = "none";
						document.getElementById("collapsePlayers:" + server)
								.style.display = "inline";
					}
					function collapsePlayers(server) {
						document.getElementById("players:" + server)
								.getElementsByTagName("td")[0]
								.getElementsByTagName("div")[0]
								.style.display = "none";
						document.getElementById("expandPlayers:" + server)
								.style.display = "inline";
						document.getElementById("collapsePlayers:" + server)
								.style.display = "none";
					}
					function toggleServer(server) {
						var properties = document.getElementById("properties:" + server)
								.getElementsByTagName("td")[0]
								.getElementsByTagName("div")[0];
						var players = document.getElementById("players:" + server)
								.getElementsByTagName("td")[0]
								.getElementsByTagName("div")[0];
						if (properties.style.display == "block"
								|| players.style.display == "block") {
							properties.style.display = "none";
							players.style.display = "none";
							document.getElementById("expandProperties:" + server)
								.style.display = "inline";
							document.getElementById("collapseProperties:" + server)
								.style.display = "none";
							document.getElementById("expandPlayers:" + server)
								.style.display = "inline";
							document.getElementById("collapsePlayers:" + server)
								.style.display = "none";
						} else {
							players.style.display = "block";
							document.getElementById("expandPlayers:" + server)
								.style.display = "none";
							document.getElementById("collapsePlayers:" + server)
								.style.display = "inline";
						}
					}
					function colorise() {
						var elements = document.getElementsByTagName("span");
						var element;
						var tokens;
						var token;
						var color;
						var span;
						var text;
						for (i = 0; i &lt; elements.length; i++) {
							element = elements[i];
							if (element.className == "colorise"
									&amp;&amp; element.hasChildNodes()) {
								tokens = "^0" + element.firstChild.data + "^0";
								element.firstChild.data = "";
								tokens = tokens.split("^");
								for (j = 1; j &lt; tokens.length; j++) {
									token = tokens[j];
									color = token.substring(0, 1);
									token = token.substring(1, token.length);
									span = document.createElement("span");
									element.appendChild(span);
									text = document.createTextNode(token);
									span.appendChild(text);
									span.setAttribute("class", "c" + color);
								}
							}
						}
					}
				</script>
				<div id="page">
					<a name="top"></a>
					<div id="header">
						<div class="title">Quake Server Poll</div>
						<div class="menu">
							::
							<a href="javascript:collapseAllProperties();"
								title="collapse all properties" class="arrow">&#8593;</a>
							properties
							<a href="javascript:expandAllProperties();"
								title="expand all properties" class="arrow">&#8595;</a>
							::
							<a href="javascript:collapseAllPlayers();"
								title="collapse all players" class="arrow">&#8593;</a>
							players
							<a href="javascript:expandAllPlayers();"
								title="expand all players" class="arrow">&#8595;</a>
							::
						</div>
					</div>
					<div id="main">
						<xsl:apply-templates select="qsp:servers" />
					</div>
					<div id="footer">
						generated by <a href="http://iekko.free.fr/devel/qsp">qsp</a>,
						on <xsl:value-of select="qsp:servers/@date" /><br />
						<a href="http://validator.w3.org/check?uri=referer">Valid HTML!</a>
						- <a href="http://jigsaw.w3.org/css-validator/check/referer">Valid CSS!</a>
					</div>
				</div>
				<script type="text/javascript">colorise();</script>
			</body>
		</html>
	</xsl:template>

	<xsl:template match="qsp:servers">
		<div class="servers">
			<table>
				<tr class="serversTitle">
					<th>Server name</th>
					<th>Address</th>
					<th>Port</th>
					<th>Map name</th>
					<th colspan="2">Players</th>
					<th>Ping</th>
					<th></th>
				</tr>
				<xsl:apply-templates select="qsp:server" />
			</table>
		</div>
		<script type="text/javascript">
			collapseAllProperties();
			collapseAllPlayers();
		</script>
	</xsl:template>

	<xsl:template match="qsp:server">
		<tr class="serverTitle"
				onMouseOver="this.className='serverTitle serverTitleOver'"
				onMouseOut="this.className='serverTitle'">
			<td onClick="toggleServer('{concat(@address, ':', @port)}')">
				<span class="colorise">
					<xsl:variable name="hostname"
							select="qsp:properties/qsp:property[@name = 'sv_hostname']/@value" />
					<xsl:choose>
						<xsl:when test="concat('x', $hostname) = 'x'">
							<xsl:value-of select="concat(@address, ':', @port)" />
						</xsl:when>
						<xsl:otherwise>
							<xsl:value-of select="$hostname" />
						</xsl:otherwise>
					</xsl:choose>
				</span>
			</td><td onClick="toggleServer('{concat(@address, ':', @port)}')">
				<xsl:value-of select="@address" />
			</td><td class="number" onClick="toggleServer('{concat(@address, ':', @port)}')">
				<xsl:value-of select="@port" />
			</td><td onClick="toggleServer('{concat(@address, ':', @port)}')">
				<xsl:value-of select="qsp:properties/qsp:property[@name = 'mapname']/@value" />
			</td><td class="number" onClick="toggleServer('{concat(@address, ':', @port)}')">
				<xsl:value-of select="qsp:properties/qsp:property[@name = '.players']/@value" />
			</td><td class="number" onClick="toggleServer('{concat(@address, ':', @port)}')">
				(<xsl:value-of select="qsp:properties/qsp:property[@name = '.slots']/@value" />)
			</td><td class="number" onClick="toggleServer('{concat(@address, ':', @port)}')">
				<xsl:value-of select="qsp:properties/qsp:property[@name = '.ping']/@value" />
			</td><td class="action">
				<a id="expandProperties:{concat(@address, ':', @port)}"
						href="javascript:expandProperties('{concat(@address, ':', @port)}')"
						title="expand properties" class="arrow">&#8595;</a>
				<a id="collapseProperties:{concat(@address, ':', @port)}"
						href="javascript:collapseProperties('{concat(@address, ':', @port)}')"
						title="collapse properties" class="arrow">&#8593;</a>
				<a id="expandPlayers:{concat(@address, ':', @port)}"
						href="javascript:expandPlayers('{concat(@address, ':', @port)}')"
						title="expand players" class="arrow">&#8595;</a>
				<a id="collapsePlayers:{concat(@address, ':', @port)}"
						href="javascript:collapsePlayers('{concat(@address, ':', @port)}')"
						title="collapse players" class="arrow">&#8593;</a>
			</td>
		</tr><tr id="properties:{concat(@address, ':', @port)}">
			<td colspan="6">
				<xsl:apply-templates select="qsp:properties">
					<xsl:with-param name="address" select="concat(@address, ':', @port)" />
				</xsl:apply-templates>
			</td>
		</tr><tr id="players:{concat(@address, ':', @port)}">
			<td colspan="6">
				<xsl:apply-templates select="qsp:players" />
			</td>
		</tr>
	</xsl:template>

	<xsl:template match="qsp:properties">
		<xsl:param name="address" />
		<div class="properties">
			<table>
				<tr>
					<th>Property</th>
					<th>Value</th>
				</tr><tr>
					<td>Name</td>
					<td>
						<span class="colorise">
							<xsl:value-of select="qsp:property[@name = 'sv_hostname']/@value" />
						</span>
					</td>
				</tr><tr>
					<td>Address</td>
					<td><xsl:value-of select="$address" /></td>
				</tr><tr>
					<td>Game name</td>
					<td><xsl:value-of select="qsp:property[@name = 'gamename']/@value" /></td>
				</tr><tr>
					<td>Map</td>
					<td><xsl:value-of select="qsp:property[@name = 'mapname']/@value" /></td>
				</tr><tr>
					<td>Version</td>
					<td><xsl:value-of select="qsp:property[@name = 'version']/@value" /></td>
				</tr><tr>
					<td>Protocol</td>
					<td><xsl:value-of select="qsp:property[@name = 'protocol']/@value" /></td>
				</tr><tr>
					<td>Time limit</td>
					<td><xsl:value-of select="qsp:property[@name = 'timelimit']/@value" /></td>
				</tr>
				<xsl:for-each select="qsp:property[
						substring(@name, 1, 1) != '.'
						and @name != 'gamename'
						and @name != 'mapname'
						and @name != 'version'
						and @name != 'protocol'
						and @name != 'sv_hostname'
						and @name != 'timelimit']">
					<tr>
						<td><xsl:value-of select="@name" /></td>
						<td><xsl:value-of select="@value" /></td>
					</tr>
				</xsl:for-each>
			</table>
		</div>
	</xsl:template>

	<xsl:template match="qsp:players">
		<div class="players">
			<table>
				<tr>
					<th>Num</th>
					<th>Score</th>
					<th>Ping</th>
					<th>Name</th>
				</tr>
				<xsl:apply-templates select="qsp:player" />
			</table>
		</div>
	</xsl:template>

	<xsl:template match="qsp:player">
		<tr>
			<td class="number">
				<xsl:value-of select="@num" />
			</td><td class="number">
				<xsl:value-of select="@score" />
			</td><td class="number">
				<xsl:value-of select="@ping" />
			</td><td>
				<span class="colorise"><xsl:value-of select="@name" /></span>
			</td>
		</tr>
	</xsl:template>

</xsl:stylesheet>

